/**********************************************************************
 * Programacin Concurrente y Distribuida
 * Ingeniera Informtica - Universidad de Cantabria
 * 
 * Proyecto: DigitalIO Driver
 * 
 * Fichero: Interfaz DigitalIOCard
 *  
 * @Autor: J.M. Drake y L. Barros
 * @Fecha: 13-10-08
 * 
 *********************************************************************/
// Interfaz que es ofrecida por las clases que controlan una tarjeta de
// IO digital, o que la simulan.
public interface DigitalIOCard {
	// Lee el buffer de entrada de la tarjeta. Slo son significativos
	// los 32 bits menos significativos de la palabra de tipo long que
	// retorna. 
	long readInputBuffer();
	
	// Escribe los 32 bits menos significativos del parmetro data en
	// el buffer de salida de la tarjeta.
	void writeOutputBuffer(long data);

	// Aade el objeto listener que se pasa como parmetro como observa-
	// dor de los cambios que se producen en las entradas digitales de 
	// la tarjeta. 
	void addInterruptListener(DigitalIOListener listener);
}
