module CruceSemaforosPkt
{
	exception IndexOutOfRange {};
	exception MeHanInterrumpido {};
	
	interface DigitalIOListenerRmt
	{
		void newChange();
	};
	
	interface DigitalIODriverRmt
	{
		void awaitChangeFalseToTrue(int line) throws IndexOutOfRange, MeHanInterrumpido;
	
		void writeOutputLine(int line, bool state) throws IndexOutOfRange;
		
		void generatePulse(int line, int width) throws IndexOutOfRange;
		
		void blinking(int line, int period) throws IndexOutOfRange;
		
	};
		
	interface DigitalIOCardRmt
	{
		long readInputBuffer();
		
		void writeOutputBuffer(long data);
		
		void addInterruptListener(DigitalIOListenerRmt *listener);
		
		void addDigitalIODriver(DigitalIODriverRmt* driver);
	};
	

	
};
