/**********************************************************************
 * Programaci�n Concurrente y Distribuida
 * Ingenier�a Inform�tica - Universidad de Cantabria
 * 
 * Proyecto: Cruce con Sem�foros
 * 
 * Fichero: Clase principal CruceSemaforos
 *  
 * @Autor: J.M. Drake y L. Barros
 * @Fecha: 5-11-08
 * 
 *********************************************************************/
import java.io.IOException;


public class CruceSemaforos {
	
	final int SEM1ROJO=0;
	final int SEM1AMBAR=1;
	final int SEM1VERDE=2;
	final int SEM2ROJO=3;
	final int SEM2AMBAR=4;
	final int SEM2VERDE=5;
	final int SEM3ROJO=6;
	final int SEM3AMBAR=7;
	final int SEM3VERDE=8;
	final int PASOPEATONES1VERDE=10;
	final int PASOPEATONES1ROJO=9;
	final int PASOPEATONES2VERDE=12;
	final int PASOPEATONES2ROJO=11;
	final int BOTONPEATONES=30;
	final int DETECTORCOCHE=31;
	final int TIMER=13;
	final int TIEMPOSINCAMBIOS=50000;
	final int TIEMPOLENTA=25000;
	final int TIEMPOAMBAR=5000;
	final int TIEMPOBLINKING=500;
	
	HabilitadaViaRapida habilitadaViaRapida;
	HabilitadaViaRapida enAmbarViaRapida;
	HabilitadaViaRapida habilitadaViaLenta;
	HabilitadaViaRapida enAmbarViaLenta;
	HabilitadaViaRapida cambiosInhibidos;
	
	
	static DigitalIODriver driver = null;
	
	boolean cambioRequerido=false;
	
	HabilitadaViaRapida currentState;
	
	
	public static void main(String[] args) {
		
		Ice.Properties propiedades = Ice.Util.createProperties(args);

//		propiedades.setProperty("Ice.ThreadPool.Server.Size", "5" );
//		propiedades.setProperty("Ice.ThreadPool.Client.Size", "5" );

		Ice.InitializationData init_data = new Ice.InitializationData();
		init_data.properties = propiedades;
		
		Ice.Communicator ic = Ice.Util.initialize(init_data);
		
		
		driver = new DigitalIODriver(ic);

	
		final CruceSemaforos tank=new CruceSemaforos();
	
        tank.currentState=tank.new HabilitadaViaRapida();
        tank.currentState.start();
		//tank.currentState.enter();
		
        Thread esperaBotonPeaton= new Thread(
        		new Runnable(){
        			public void run(){
        				while(true){
        					try{
        						tank.driver.awaitChangeFalseToTrue(tank.BOTONPEATONES);
        					}catch (IndexOutOfRange e){}
        					catch (InterruptedException e){}
        					tank.currentState.requiereCambio();
        				}
        			}
                }
        );
        esperaBotonPeaton.setDaemon(true);
        esperaBotonPeaton.start();
        
        Thread esperaCocheDetectado= new Thread(
        		new Runnable(){
        			public void run(){
        				while(true){
        					try{
        						tank.driver.awaitChangeFalseToTrue(tank.DETECTORCOCHE);
        					}catch (IndexOutOfRange e){}
        					catch (InterruptedException e){}
        					tank.currentState.requiereCambio();
        				}
        			}
                }
        );
        esperaCocheDetectado.setDaemon(true);
        esperaCocheDetectado.start();        
        char c='_';
		while((c!='F') && (c!='F')){
			try {c=(char)System.in.read();
			} catch (IOException e) {}
		}
	}
	
	private class HabilitadaViaRapida{
		
		public HabilitadaViaRapida(){}
		public void start(){
			habilitadaViaRapida=this;
			enAmbarViaRapida=new EnAmbarViaRapida();
			habilitadaViaLenta=new HabilitadaViaLenta();
			enAmbarViaLenta=new EnAmbarViaLenta();
			cambiosInhibidos=new CambiosInhibidos();
			enter();
		}
		
		public void doWork(){}
		
		public void enter(){
			try{
			driver.writeOutputLine(SEM1ROJO,true);
			driver.writeOutputLine(SEM1AMBAR,false);
			driver.writeOutputLine(SEM1VERDE,false);
			driver.writeOutputLine(SEM2ROJO,false);
			driver.writeOutputLine(SEM2AMBAR,false);
			driver.writeOutputLine(SEM2VERDE,true);
			driver.writeOutputLine(SEM3ROJO,false);
			driver.writeOutputLine(SEM3AMBAR,false);
			driver.writeOutputLine(SEM3VERDE,true);
			driver.writeOutputLine(PASOPEATONES1VERDE,true);
			driver.writeOutputLine(PASOPEATONES1ROJO,false);	
			driver.writeOutputLine(PASOPEATONES2VERDE,false);
			driver.writeOutputLine(PASOPEATONES2ROJO,true);	
			doWork();
			}catch(IndexOutOfRange e){}
		}
		
		public void exit(){
			cambioRequerido=false;
			currentState=enAmbarViaRapida;
			currentState.enter();
		}
		
		public void requiereCambio(){
			exit();
			
		}
	}
	
	private class EnAmbarViaRapida extends HabilitadaViaRapida{
		public EnAmbarViaRapida(){}
		
		public void doWork(){
			try{
				driver.awaitChangeFalseToTrue(SEM2AMBAR);
			}catch(IndexOutOfRange e){}
			catch(InterruptedException e){}
			exit();
		}
		
		public void enter(){
			try{
			driver.writeOutputLine(SEM1ROJO,true);
			driver.writeOutputLine(SEM1AMBAR,false);
			driver.writeOutputLine(SEM1VERDE,false);
			driver.writeOutputLine(SEM2ROJO,false);
			driver.generatePulse(SEM2AMBAR,TIEMPOAMBAR);
			driver.writeOutputLine(SEM2VERDE,false);
			driver.writeOutputLine(SEM3ROJO,false);
			driver.writeOutputLine(SEM3AMBAR,true);
			driver.writeOutputLine(SEM3VERDE,false);
			driver.blinking(PASOPEATONES1VERDE,TIEMPOBLINKING);
			driver.writeOutputLine(PASOPEATONES1ROJO,false);	
			driver.writeOutputLine(PASOPEATONES2VERDE,false);
			driver.writeOutputLine(PASOPEATONES2ROJO,true);	
			doWork();
			}catch(IndexOutOfRange e){}
		}
		
		public void exit(){
			currentState=habilitadaViaLenta;
			currentState.enter();
		}
		
		public void peatonPulsaBoton(){}
		public void cocheEnViaLenta(){}
	}
	
	private class HabilitadaViaLenta extends HabilitadaViaRapida{
		public HabilitadaViaLenta(){}
		
		public void doWork(){
			try{
				driver.awaitChangeFalseToTrue(SEM1VERDE);
			}catch(IndexOutOfRange e){}
			catch(InterruptedException e){}
			exit();
		}
		
		public void enter(){
			try{
			driver.writeOutputLine(SEM1ROJO,false);
			driver.writeOutputLine(SEM1AMBAR,false);
			driver.generatePulse(SEM1VERDE,TIEMPOLENTA);
			driver.writeOutputLine(SEM2ROJO,true);
			driver.writeOutputLine(SEM2AMBAR,false);
			driver.writeOutputLine(SEM2VERDE,false);
			driver.writeOutputLine(SEM3ROJO,true);
			driver.writeOutputLine(SEM3AMBAR,false);
			driver.writeOutputLine(SEM3VERDE,false);
			driver.writeOutputLine(PASOPEATONES1VERDE,false);
			driver.writeOutputLine(PASOPEATONES1ROJO,true);	
			driver.writeOutputLine(PASOPEATONES2VERDE,true);
			driver.writeOutputLine(PASOPEATONES2ROJO,false);	
			doWork();
			}catch(IndexOutOfRange e){}
		}
		
		public void exit(){
			currentState=enAmbarViaLenta;
			currentState.enter();
		}
		
		public void requiereCambio(){}
	}
	
	private class EnAmbarViaLenta extends HabilitadaViaRapida{
		public EnAmbarViaLenta(){}
		public void doWork(){
			try{
				driver.awaitChangeFalseToTrue(SEM1AMBAR);
			}catch(IndexOutOfRange e){}
			catch(InterruptedException e){}
			exit();
		}
		
		public void enter(){
			try{
			driver.writeOutputLine(SEM1ROJO,false);
			driver.generatePulse(SEM1AMBAR,TIEMPOAMBAR);
			driver.writeOutputLine(SEM1VERDE,false);
			driver.writeOutputLine(SEM2ROJO,true);
			driver.writeOutputLine(SEM2AMBAR,false);
			driver.writeOutputLine(SEM2VERDE,false);
			driver.writeOutputLine(SEM3ROJO,true);
			driver.writeOutputLine(SEM3AMBAR,false);
			driver.writeOutputLine(SEM3VERDE,false);
			driver.writeOutputLine(PASOPEATONES1VERDE,false);
			driver.writeOutputLine(PASOPEATONES1ROJO,true);	
			driver.blinking(PASOPEATONES2VERDE,TIEMPOBLINKING);
			driver.writeOutputLine(PASOPEATONES2ROJO,false);	
			doWork();
			}catch(IndexOutOfRange e){}
		}
		
		public void exit(){
			currentState=cambiosInhibidos;
			currentState.enter();
		}
		
		public void requiereCambio(){cambioRequerido=true;}
	}
	
	private class CambiosInhibidos extends HabilitadaViaRapida{
		public CambiosInhibidos(){}
		
		public void doWork(){
			try{
				driver.awaitChangeFalseToTrue(TIMER);
			}catch(IndexOutOfRange e){}
			catch(InterruptedException e){}
			exit();
		}
		
		public void enter(){
			try{
			driver.writeOutputLine(SEM1ROJO,true);
			driver.writeOutputLine(SEM1AMBAR,false);
			driver.writeOutputLine(SEM1VERDE,false);
			driver.writeOutputLine(SEM2ROJO,false);
			driver.writeOutputLine(SEM2AMBAR,false);
			driver.writeOutputLine(SEM2VERDE,true);
			driver.writeOutputLine(SEM3ROJO,false);
			driver.writeOutputLine(SEM3AMBAR,false);
			driver.writeOutputLine(SEM3VERDE,true);
			driver.writeOutputLine(PASOPEATONES1VERDE,true);
			driver.writeOutputLine(PASOPEATONES1ROJO,false);	
			driver.writeOutputLine(PASOPEATONES2VERDE,false);
			driver.writeOutputLine(PASOPEATONES2ROJO,true);
			driver.generatePulse(TIMER, TIEMPOSINCAMBIOS-TIEMPOLENTA-2*TIEMPOAMBAR);
			doWork();
			}catch(IndexOutOfRange e){}
		}
		
		public void exit(){
			if (cambioRequerido){
				cambioRequerido=false;
				currentState=enAmbarViaRapida;
			}else{
				currentState=habilitadaViaRapida;
			}
			currentState.enter();
		}
		
		public void requiereCambio(){cambioRequerido=true;}
	}
}
